version: "3.3"

services:
  database:
    image: postgres
    volumes:
      - db_data:/var/lib/postgresql/data
      - ./init.sql:/docker-entrypoint-initdb.d/init.sql

  redis:
    image: redis
    command: redis-server --appendonly yes
    hostname: redis
    ports:
      - "6379"
    volumes:
      - /home/duducp/Redis:/var/lib/postgresql/data

  rabbitmq:
    image: "rabbitmq:3-management"
    hostname: "rabbitmq"
    environment:
      RABBITMQ_ERLANG_COOKIE: "SWQOKODSQALRPCLNMEQG"
      RABBITMQ_DEFAULT_USER: "guest"
      RABBITMQ_DEFAULT_PASS: "guest"
      RABBITMQ_DEFAULT_VHOST: "/"
    ports:
      - "15672:15672"
      - "5672:5672"
    labels:
      NAME: "rabbitmq"
    volumes:
      - "./enabled_plugins:/etc/rabbitmq/enabled_plugins"

  web:
    build: .
    volumes:
      - .:/app:cached
    command: bash -c "rm -f tmp/pids/server.pid && bundle exec rails s -p 3000 -b '0.0.0.0'"
    ports:
      - "3000:3000"
    depends_on:
      - database
      - redis
      - rabbitmq
    environment:
      RAILS_ENV: development
      DATABASE_NAME: health_status
      DATABASE_USER: postgres
      DATABASE_PASSWORD: admin
      DATABASE_HOST: database
      REDIS_DB: main_cache
      REDIS_URL: redis://redis
      REDIS_PORT: 6379
      RABBIT_MQ_HOST: rabbitmq 

volumes:
  db_data:
